package com.sunyard.chsm.utils;

/**
 * @author liulu
 * @version V1.0
 * @since 2020/11/16
 */
public abstract class ThrowableUtils {

    private ThrowableUtils() {
    }


    public static String buildErrorMessage(Throwable ex) {
        StringBuilder sb = new StringBuilder();
        sb.append(ex.getMessage());
        StackTraceElement[] stackTrace = ex.getStackTrace();
        int i = 0;
        for (StackTraceElement stackTraceElement : stackTrace) {
            if (i++ >= 5) {
                break;
            }
            sb.append("\n\t").append(stackTraceElement.toString());
        }
        return sb.toString();
    }


    public static <T extends Exception> T findException(Class<T> exClass, Throwable ex) {
        for (int i = 0; ex != null && i < 3; i++) {
            if (exClass.isAssignableFrom(ex.getClass())) {
                //noinspection unchecked
                return (T) ex;
            }
            ex = ex.getCause();
        }
        return null;
    }


}
